using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Demo
{
	/// <summary>
 /// Summary description for DmoSelect.
	/// </summary>
 internal class DmoSelect : System.Windows.Forms.Form
	{
  private Demo dm;

		private System.Windows.Forms.Button OK;
		private System.Windows.Forms.Button Cancel;
 	private System.Windows.Forms.GroupBox groupBox1;
  private System.Windows.Forms.ListBox box;
  
  /// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

  public DmoSelect(Demo parent)
		{
     dm=parent;           // set the parent class

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.OK = new System.Windows.Forms.Button();
			this.Cancel = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.box = new System.Windows.Forms.ListBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// OK
			// 
			this.OK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.OK.Location = new System.Drawing.Point(40, 192);
			this.OK.Name = "OK";
			this.OK.Size = new System.Drawing.Size(80, 24);
			this.OK.TabIndex = 4;
			this.OK.Text = "OK";
			this.OK.Click += new System.EventHandler(this.OK_Click);
			// 
			// Cancel
			// 
			this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Cancel.Location = new System.Drawing.Point(128, 192);
			this.Cancel.Name = "Cancel";
			this.Cancel.Size = new System.Drawing.Size(80, 24);
			this.Cancel.TabIndex = 5;
			this.Cancel.Text = "Cancel";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.box});
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(200, 184);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			// 
			// box
			// 
			this.box.Location = new System.Drawing.Point(8, 16);
			this.box.Name = "box";
			this.box.Size = new System.Drawing.Size(184, 160);
			this.box.TabIndex = 0;
			this.box.DoubleClick += new System.EventHandler(this.box_DoubleClick);
			// 
			// DmoSelect
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.Cancel;
			this.ClientSize = new System.Drawing.Size(216, 221);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox1,
																		  this.Cancel,
																		  this.OK});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DmoSelect";
			this.Text = "Select an Open TE Control";
			this.Load += new System.EventHandler(this.DmoSelect_Load);
			this.Activated += new System.EventHandler(this.DmoSelect_Activated);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

  private void DmoSelect_Load(object sender, System.EventArgs ev)
  {
     int i;

     dm.CurCtl=-1;   // reset selected control

     for (i=0;i<Demo.MAX_CTLS;i++) {
        if (dm.ctl[i].InUse && dm.ctl[i].toc!=null) box.Items.Add(new ClsBox(dm.ctl[i].form.Text,i));
     }
     box.SelectedIndex=0; 
  }
  private void DmoSelect_Activated(object sender, System.EventArgs e)
  {
     box.Focus();
  }
  
  private void OK_Click(object sender, System.EventArgs ev)
		{
     ClsBox item=(ClsBox)(box.SelectedItem);
     dm.CurCtl=item.value;
  }

  private void box_DoubleClick(object sender, System.EventArgs ev)
  {
     DialogResult=DialogResult.OK;
     OK_Click(sender,ev);
     if (DialogResult==DialogResult.OK) this.Hide();
  }
 

  ////////////////////////////////////////////////////////////////////////////////////////
  //////////// Helper functions
  ////////////////////////////////////////////////////////////////////////////////////////
  /***************************************************************************
      ToInt:
      Convert string to integer
  ****************************************************************************/
  internal new int ToInt(TextBox item)
  {
     return ToInt(item.Text);
  }

  internal new int ToInt(string txt)
  {
     try {
        return (int)Convert.ToInt32(txt);
     } 
     catch (System.Exception)
     {
        return 0;
     }
  } 


	}
 //////////////////////////////////////////////////////////////////////////////////////
 /// Helper class to fill the list box
 /////////////////////////////////////////////////////////////////////////////////////
 public class ClsBox {          // list box/combo-box object
    internal string item;         // string
    internal int    value;        // item value
    public ClsBox(string ArgItem,int ArgValue)
    {
       item=ArgItem;
       value=ArgValue;
    }
    public override string ToString() {return item;}
 }

}
